<?php

namespace App\Entity;

use App\Repository\EmailRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: EmailRepository::class)]
class Email
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 255)]
    private ?string $email = null;

    #[ORM\Column(length: 255)]
    private ?string $unsubscribeToken = null;

    #[ORM\Column(type: Types::DATETIME_MUTABLE, nullable: true)]
    private ?\DateTimeInterface $lastNotificationSentAt = null;

    #[ORM\Column]
    private ?int $pendingEmails = null;

    #[ORM\Column]
    private ?bool $sendReplyNotifications = null;

    #[ORM\Column]
    private ?bool $sendModeratorNotifications = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): static
    {
        $this->email = $email;

        return $this;
    }

    public function getUnsubscribeToken(): ?string
    {
        return $this->unsubscribeToken;
    }

    public function setUnsubscribeToken(string $unsubscribeToken): static
    {
        $this->unsubscribeToken = $unsubscribeToken;

        return $this;
    }

    public function getLastNotificationSentAt(): ?\DateTimeInterface
    {
        return $this->lastNotificationSentAt;
    }

    public function setLastNotificationSentAt(?\DateTimeInterface $lastNotificationSentAt): static
    {
        $this->lastNotificationSentAt = $lastNotificationSentAt;

        return $this;
    }

    public function getPendingEmails(): ?int
    {
        return $this->pendingEmails;
    }

    public function setPendingEmails(int $pendingEmails): static
    {
        $this->pendingEmails = $pendingEmails;

        return $this;
    }

    public function isSendReplyNotifications(): ?bool
    {
        return $this->sendReplyNotifications;
    }

    public function setSendReplyNotifications(bool $sendReplyNotifications): static
    {
        $this->sendReplyNotifications = $sendReplyNotifications;

        return $this;
    }

    public function isSendModeratorNotifications(): ?bool
    {
        return $this->sendModeratorNotifications;
    }

    public function setSendModeratorNotifications(bool $sendModeratorNotifications): static
    {
        $this->sendModeratorNotifications = $sendModeratorNotifications;

        return $this;
    }
}
